/*
        FILE :                  texture.cpp

        DESCRIPTION :           Textures loader

        AUTHOR :                Trax / Aspirine (c), 1999

        VERSION :               0.1b
*/

//// INCLUDES /////////////////////////////////////////////////////////////////

#include "texture.h"
#include "pcx.h"
#include <stdio.h>
#include <stdlib.h>


//// FUNCTIONS ////////////////////////////////////////////////////////////////

int load_textmap(SCENE *scene, int texturenro, char *fn)
{
        printf("loading texturemap..(%s)\n", fn);

        scene->textm[texturenro].filename = fn;
        scene->textm[texturenro].palette = (byte *)malloc(768);
        scene->textm[texturenro].data = (byte *)malloc(65536);

        if (loadpcx(scene->textm[texturenro]) == -1)
        {
                printf("file (%s) not found.\n", fn);
                return -1;
        }
        return 0;
}

///////////////////////////////////////////////////////////////////////////////

void free_textmap(SCENE *scene, int texturenro)
{
        if (scene->textm[texturenro].palette != NULL) free(scene->textm[texturenro].palette);
        if (scene->textm[texturenro].data != NULL) free(scene->textm[texturenro].data);
}

/*//////////////////////////////////////////////////////////////////////////*/
